#include <stdio.h>
#include <stdlib.h>
#include "bintree.h"

#ifndef NULL
#define NULL ((void*)0)
#endif

btnode **rbsearch (btnode **ppnode, int key) {

	btnode *pnode = *ppnode;

	if (pnode == (btnode*)NULL) {
		return ppnode;
	}

	printf("Looking for key %d at node containing %d\n", 
			key, pnode->key);

	if (key == pnode->key) {
		return ppnode;
	}

	if (key < pnode->key) {
		printf("Going left\n");
		return rbsearch(&(pnode->l), key);
	} else {
		printf("Going right\n");
		return rbsearch(&(pnode->r), key);
	}
}
	
	
btnode *newbtnode (int key) {
	btnode *tmp;
	tmp = (btnode*)malloc(sizeof(btnode));
	if (tmp == (btnode*)NULL) {
		return tmp;
	}

	tmp->key = key;
	tmp->l = (btnode*)NULL;
	tmp->r = (btnode*)NULL;
	return tmp;
}

int insert (btnode **tree, int key) {
	btnode **tmp = rbsearch(tree, key);

	if ((*tmp) != (btnode*)NULL) {
		return FAILURE;
	} else {
		(*tmp) = newbtnode(key);
		if ((*tmp) != (btnode*)NULL) {
			return FAILURE;
		}
	}
	return SUCCESS;
}


