#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "sbintree.h"

#ifndef NULL
#define NULL ((void*)0)
#endif

btnode **rbsearch (btnode **ppnode, char *key) {

	btnode *pnode = *ppnode;
	int comparison;

	if (pnode == (btnode*)NULL) {
		return ppnode;
	}

	printf("Looking for key <%s> at node containing <%s>\n", 
			key, pnode->key);

	comparison = strcmp(key, pnode->key);
	if (comparison == 0) {
		return ppnode;
	}

	if (comparison < 0) {
		printf("Going left\n");
		return rbsearch(&(pnode->l), key);
	} else {
		printf("Going right\n");
		return rbsearch(&(pnode->r), key);
	}
}
	
	
btnode *newbtnode (char *key) {
	btnode *tmp;
	tmp = (btnode*)malloc(sizeof(btnode));
	if (tmp == (btnode*)NULL) {
		return tmp;
	}

	tmp->key = strdup(key);
	if (tmp->key == (char*)NULL) {
		free(tmp);
		return NULL;
	}
	tmp->l = (btnode*)NULL;
	tmp->r = (btnode*)NULL;
	return tmp;
}

void delbtnode (btnode *victim) {
	free (victim->key);
	free (victim);
}


int insert (btnode **tree, char *key) {
	btnode **tmp = rbsearch(tree, key);

	if ((*tmp) != (btnode*)NULL) {
		return FAILURE;
	} else {
		(*tmp) = newbtnode(key);
		if ((*tmp) != (btnode*)NULL) {
			return FAILURE;
		}
	}
	return SUCCESS;
}


